<template>
  <p>ผู้ยืมอุปกรณ์ปัจจุบัน</p>
  <div class="card">
    <v-btn variant="text" icon="mdi-arrow-left" @click="back"></v-btn>
    <v-infinite-scroll v-if="loaded" mode="manual" max-height="1000">
      <template v-for="(request) in requests" :key="request.id">
        <v-expansion-panels class="px-4 py-1">
          <v-expansion-panel>
            <v-expansion-panel-title>
              <v-img v-if="request.attributes.equipment.data.attributes.image.data && request.attributes.equipment.data.attributes.image.data.length > 0"
                :src="media + request.attributes.equipment.data.attributes.image.data[0].attributes.url"
                :aspect-ratio="1" width="70" class="img" cover />
              <img v-else src="/assets/image/non-equipment.jpg" :aspect-ratio="1" width="70" class="img" cover />
              <div class="d-flex px-2 detail">
                <p v-if="request.attributes.equipment.data.attributes.name.length <= 20">
                  {{ request.attributes.equipment.data.attributes.name }}</p>
                <p v-else>{{ request.attributes.equipment.data.attributes.name.slice(0, 20) }}...</p>
              </div>
              <p class="text-green-darken-3 text-sm text-wrap align-center pr-3 text-end">อยู่ระหว่างการยืม</p>
            </v-expansion-panel-title>
            <div class="d-flex flex-row">
              <p class="text-sm ml-3 text-no-wrap">
                {{ request.attributes.equipment.data.attributes.provider_name }}</p>
              <p class="text-id text-end align-self-center pr-2">รายการ {{ request.id }}</p>
            </div>
            <v-expansion-panel-text>
              <div class="d-flex flex-column border-t-sm">
                <div class="d-flex">
                  <p class="text-sm">รายละเอียด</p>
                  <p v-if="request.attributes.equipment.data.attributes.detail" class="text-sm">
                    {{ request.attributes.equipment.data.attributes.detail }}</p>
                  <p v-else> - </p>
                </div>
                <div class="d-flex">
                  <p class="text-sm">ระยะเวลาในการยืม</p>
                  <p class="text-sm">{{ request.attributes.equipment.data.attributes.day_limit }} <span>วัน</span>
                  </p>
                </div>
                <div class="d-flex">
                  <p class="text-sm">จำนวน</p>
                  <p class="text-sm">× 1</p>
                </div>
                <div class="d-flex">
                  <p class="text-sm">กำหนดการคืน</p>
                  <p class="text-sm">{{ formatDateThai(request.attributes.return_schedule) }}</p>
                </div>
                <div class="d-flex">
                  <p class="text-sm">ผู้ยืม</p>
                  <p class="text-sm">{{ request.attributes.user.data.attributes.prefix +
                    request.attributes.user.data.attributes.firstname + " " +
                    request.attributes.user.data.attributes.lastname }}
                  </p>
                </div>
                <div class="d-flex">
                  <p class="text-sm">ผู้อนุมัติยืม</p>
                  <p class="text-sm">{{ request.attributes.giver }}</p>
                </div>
                <div class="d-flex">
                  <span class="text-time">อนุมัติเมื่อ {{ formatDateTime(request.attributes.updatedAt) }}</span>
                </div>
              </div>
            </v-expansion-panel-text>
          </v-expansion-panel>
        </v-expansion-panels>
      </template>

      <template v-slot:load-more>
        no more
      </template>
    </v-infinite-scroll>

    <div v-if="!loaded" class="card d-flex flex-column mb-2">
      <v-skeleton-loader type="heading"></v-skeleton-loader>
      <v-skeleton-loader type="list-item-avatar"></v-skeleton-loader>
      <v-skeleton-loader type="list-item-two-line"></v-skeleton-loader>
      <v-skeleton-loader type="list-item-avatar"></v-skeleton-loader>
      <v-skeleton-loader type="list-item-two-line"></v-skeleton-loader>
      <v-skeleton-loader type="list-item-avatar"></v-skeleton-loader>
      <v-skeleton-loader type="list-item-two-line"></v-skeleton-loader>
      <v-skeleton-loader type="list-item-avatar"></v-skeleton-loader>
      <v-skeleton-loader type="list-item-two-line"></v-skeleton-loader>
      <v-skeleton-loader type="list-item-avatar"></v-skeleton-loader>
      <v-skeleton-loader type="list-item-two-line"></v-skeleton-loader>
      <v-skeleton-loader type="list-item-avatar"></v-skeleton-loader>
      <v-skeleton-loader type="list-item-two-line"></v-skeleton-loader>
    </div>
  </div>
</template>

<script setup>
useHead({
  title: "ระบบยืม-คืน | ผู้ยืมอุปกรณ์ปัจจุบัน",
  meta: [{ name: "description", content: "ผู้ยืมอุปกรณ์ปัจจุบัน" }],
});
definePageMeta({
  middleware: "auth",
});

import { ref, onMounted } from "vue";
import axios from "axios";

const token = useStrapiToken()
const url = useStrapiUrl()
const media = useStrapiMedia()

const providerData = ref()
const requests = ref([])

const loaded = ref(false)

async function getUserRequest() {
  const { id } = useRoute().params;

  try {
    axios.get(`${url}/requests`, {
      params: {
        filters: {
          department: providerData.value.department.id,
          equipment: {
            id: id,
          }
        },
        populate: {
          equipment: {
            populate: {
              image: {
                fields: {
                  0: 'url'
                }
              }
            }
          },
          user: {
            fields: {
              1: 'prefix',
              2: 'firstname',
              3: 'lastname',
            },
          }
        },
      },
      headers: {
        Authorization: `Bearer ${token.value}`,
      },
    }).then((response)=>{
      requests.value = response.data.data.reverse()
    })

  } catch (error) {
    console.log(error.error)
  }
}

async function getProviderDate() {
  const response = await axios.get(`${url}/users/me`, {
    params: {
      populate: {
        department: {
          fields: {
            0: 'id',
          }
        }
      }
    },
    headers: {
      'Authorization': `Bearer ${token.value}`,
    }
  })

  providerData.value = response.data
}

const formatDateThai = (dateStr) => {
  if (dateStr === null) {
    return 'Invalid date';
  }

  const monthsTh = ['มกราคม', 'กุมภาพันธ์', 'มีนาคม', 'เมษายน', 'พฤษภาคม', 'มิถุนายน', 'กรกฎาคม', 'สิงหาคม', 'กันยายน', 'ตุลาคม', 'พฤศจิกายน', 'ธันวาคม'];
  const parts = dateStr.split("-");
  const day = parseInt(parts[2], 10); // แปลงเป็นตัวเลขเพื่อตัด 0 ด้านหน้า
  const monthIndex = parseInt(parts[1], 10) - 1;
  const year = parseInt(parts[0], 10) + 543; // เพิ่ม 543 เพื่อแปลงเป็น พ.ศ.

  const formattedDay = day.toString();
  const formattedMonth = monthsTh[monthIndex];

  return `${formattedDay} ${formattedMonth} ${year}`;
}

const formatDateTime = (timestamp) => {
  const utcDateTime = new Date(timestamp);
  const options = {
    year: 'numeric', month: '2-digit', day: '2-digit',
    hour: '2-digit', minute: '2-digit', second: '2-digit',
    timeZone: 'Asia/Bangkok'
  };
  return utcDateTime.toLocaleString('th-TH', options);
};

async function back() {
  window.history.back();
}

onMounted(async () => {
  await getProviderDate();
  await getUserRequest();
  loaded.value = true
})
</script>

<style>
p {
  font-size: 16px;
  width: 100%;
  padding: 5px;
}

.card {
  border-radius: 5px;
  background-color: white;
}

.img {
  border-radius: 5px;
  box-shadow: 0 2px 2px rgba(0, 0, 0, 0.05);
}

.detail {
  width: 100%;
}

.text-sm {
  font-size: 14px;
}

.text-id {
  font-size: 12px;
}

.text-time {
  font-size: 10px;
  padding: 0 5px;
}

.card {
  border-radius: 5px;
  background-color: white;
  margin-bottom: 5px;
}

.btn {
  width: 150px;
}

@media (max-width: 549px) {
  .text-detail {
    font-size: 12px;
  }
  @media (max-width: 375px) {
    p {
      font-size: 14px;
    }
  }
}
</style>